package com.projectwork.demo.service;

import com.projectwork.demo.model.Orderline;
import com.projectwork.demo.model.User;
import com.projectwork.demo.model.UserCompanyRole;
import com.projectwork.demo.repository.UserCompanyRoleRepository;
import com.projectwork.demo.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

/**
* Generated by Spring Data Generator on 12/01/2023
*/
@Component
public class UserService implements Serializable {

	@Autowired
	private UserRepository userRepository;

	@Autowired
	private UserCompanyRoleRepository userCompanyRoleRepository;

	public List<User> findAllUsers() {
		List<User> users = userRepository.findAll();
		return users;
	}

	public List<UserCompanyRole> findAllUsersCompanyRole() {
		List<UserCompanyRole> usersCompanyRole = userCompanyRoleRepository.findAll();
		return usersCompanyRole;
	}

	public List<UserCompanyRole> findUserCompanyRoles(int userId){
		List<UserCompanyRole> usersCompanyRole = userCompanyRoleRepository.findAll();
		return usersCompanyRole
				.stream()
				.filter(userCompanyRole -> userCompanyRole.getUser().getUserId()==userId)
				.collect(Collectors.toList());
	}

	public boolean isButtonEnabled(User user,Orderline orderline){
		//For both case buyer or supplier check if user can do this action in according with
		//his role/permission and row status
		return true;
	}


}
